#include "mainwindow.h"  // mainwindow.cpp ̃wb_[t@C mainwindow.h ǂݍ

Mainwindow::Mainwindow(QWidget *parent, const char *name)
		: QWidget(parent, name), buffer( 640, 480 )
{
	// eLXgR[fbNucodecv쐬
	// ȍ~Acodec->toUnicode("ɏƂ͓{ŕ\ł")
	codec = QTextCodec::codecForName("ShiftJIS");

	// EBhẼ^Cgݒ
	setCaption(codec->toUnicode("TvPQuʂɃ^b`yŊGv"));

	// gptHgݒ
	QFont f("lcfont",18);
	setFont(f);
	
	QLabel *ql = new QLabel(this);
	ql -> setBackgroundColor(QColor::QColor( 100, 150, 200 ) );
	ql -> setGeometry(0,0,640,70);
	
	// `̃^Cv̉摜[h
	fm_pen.load("/mnt/card/fm_pen.jpg");
	fm_line.load("/mnt/card/fm_line.jpg");
	fm_rightangle.load("/mnt/card/fm_rightangle.jpg");
	fm_rectangle.load("/mnt/card/fm_rectangle.jpg");
	fm_paintrectangle.load("/mnt/card/fm_paintrectangle.jpg");
	fm_eraser.load("/mnt/card/fm_eraser.jpg");
	fm_stamp.load("/mnt/card/fm_stamp.jpg");
	fm_range.load("/mnt/card/fm_range.jpg");
	
	// ̃^Cv̉摜[h
	fm_thickline.load("/mnt/card/fm_thickline.jpg");
	fm_normalline.load("/mnt/card/fm_normalline.jpg");
	fm_thinline.load("/mnt/card/fm_thinline.jpg");
	
	// ʂԂlp̃^Cv̉摜[h
	fm_paint.load("/mnt/card/fm_paint.jpg");
	
	// S̃^Cv̉摜[h
	fm_minieraser.load("/mnt/card/fm_minieraser.jpg");
	
	pen_type = new QComboBox( this );
	pen_type -> insertItem(fm_pen, codec->toUnicode("y"));
	pen_type -> insertItem(fm_line, codec->toUnicode(""));
	pen_type -> insertItem(fm_rightangle, codec->toUnicode("p"));
	pen_type -> insertItem(fm_rectangle, codec->toUnicode("lp"));
	pen_type -> insertItem(fm_paintrectangle, codec->toUnicode("lp"));
	pen_type -> insertItem(fm_eraser, codec->toUnicode("S"));
	pen_type -> insertItem(fm_stamp, codec->toUnicode("X^v"));
	pen_type -> insertItem(fm_range, codec->toUnicode("͈"));
	pen_type -> setGeometry(10,35,145,30);
	
	bar_type = new QComboBox( this );
	bar_type -> insertItem(fm_thinline, codec->toUnicode("א"));
	bar_type -> insertItem(fm_normalline, codec->toUnicode(""));
	bar_type -> insertItem(fm_thickline, codec->toUnicode("ɑ"));
	bar_type -> setGeometry(165,35,145,30);
	
	color = new QPushButton(this);
	color -> setText(codec->toUnicode("F"));
	color -> setGeometry(320,35,100,30);
	
	bgcolor = new QPushButton(this);
	bgcolor -> setText(codec->toUnicode("wiF"));
	bgcolor -> setGeometry(430,35,100,30);
	bgcolor -> hide(); // ݒ̓y[hȂ̂ŔwiF{^͔\
	
	erase = new QPushButton(this);
	erase -> setText(codec->toUnicode(""));
	erase -> setGeometry(540,35,90,30);

	// j[o[ʏɔzu
	menubar = new QMenuBar( this );
	QPopupMenu *m_edit = new QPopupMenu(this);  // j[ځum_customizev쐬
	m_edit->insertItem( codec->toUnicode("폜"), this, SLOT(slot_delete()) );
	m_edit->insertItem( codec->toUnicode("Jbg"), this, SLOT(slot_cut()) );
	m_edit->insertItem( codec->toUnicode("Rs["), this, SLOT(slot_copy()) );
	m_edit->insertItem( codec->toUnicode("y[Xg"), this, SLOT(slot_paste()) );
	m_edit->insertSeparator();
	m_edit->insertItem( codec->toUnicode("摜"), this, SLOT(slot_adjustment()) );
	m_edit->insertItem( codec->toUnicode("F"), this, SLOT(slot_decrease()) );
	m_edit->insertItem( codec->toUnicode("摜"), this, SLOT(slot_effect()) );
	
	QPopupMenu *m_menu = new QPopupMenu(this);  // j[ځum_menuv쐬
	m_menu->insertItem( codec->toUnicode("J"), this, SLOT(slot_open()) );
	m_menu->insertItem( codec->toUnicode("ۑ"), this, SLOT(slot_save()) );
	m_menu->insertSeparator();
	m_menu->insertItem( codec->toUnicode("I"), qApp, SLOT(quit()) );
	
	// j[o[umenubarvɍڂǉBŒǉɍ\B
	menubar->insertItem( codec->toUnicode("j["), m_menu );  // j[o[umenubarvɁum_menuvuj[vƂ\Œǉ
	menubar->insertItem( codec->toUnicode("ҏW"), m_edit );  // j[o[Ɂum_editvuҏWvƂ\Œǉ
	menubar->setSeparator( QMenuBar::InWindowsStyle );  // EBhEY݂ȃX^C
	
	index = 0;
	pen_size = 0;
	
	// ỹ^CvςƂ̃VOi̐ݒ
	QObject::connect( pen_type, SIGNAL(activated(int)), this, SLOT(slot_setPen()) );
	QObject::connect( bar_type, SIGNAL(activated(int)), this, SLOT(slot_change_PenSize()) );
	
	buffer.fill( colorGroup().base() );
	setBackgroundMode( QWidget::PaletteBase );
}



// ỹTCYIꂽ̐ݒ
void Mainwindow::slot_change_PenSize()
{
	pen_size = bar_type -> currentItem();  // ݁AR{{bNXubar_typevőIĂ鍀ڂ̔ԍ
}



// yIꂽ̐ݒ
void Mainwindow::slot_setPen()
{
	index = pen_type -> currentItem();  // ݁AR{{bNXupen_typevőIĂ鍀ڂ̔ԍ
	
	if(index == 0) {
		// yIĂꍇ
		color -> show();
		bgcolor -> hide();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_thinline, codec->toUnicode("א"));
		bar_type -> insertItem(fm_normalline, codec->toUnicode(""));
		bar_type -> insertItem(fm_thickline, codec->toUnicode("ɑ"));
	} else if(index == 1) {
		// IĂꍇ
		color -> show();
		bgcolor -> show();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_thinline, codec->toUnicode("א"));
		bar_type -> insertItem(fm_normalline, codec->toUnicode(""));
		bar_type -> insertItem(fm_thickline, codec->toUnicode("ɑ"));
	} else if(index == 2) {
		// pIĂꍇ
		color -> show();
		bgcolor -> show();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_thinline, codec->toUnicode("א"));
		bar_type -> insertItem(fm_normalline, codec->toUnicode(""));
		bar_type -> insertItem(fm_thickline, codec->toUnicode("ɑ"));
	} else if(index == 3) {
		// lpiʂԂȂjIĂꍇ
		color -> show();
		bgcolor -> show();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_thinline, codec->toUnicode("א"));
		bar_type -> insertItem(fm_normalline, codec->toUnicode(""));
		bar_type -> insertItem(fm_thickline, codec->toUnicode("ɑ"));
	} else if(index == 4) {
		// lpiʂԂjIĂꍇ
		color -> show();
		bgcolor -> show();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_paint, codec->toUnicode("x^"));
	} else if(index == 5) {
		// SIĂꍇ
		color -> hide();
		bgcolor -> hide();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(fm_minieraser, codec->toUnicode(""));
		bar_type -> insertItem(fm_eraser, codec->toUnicode(""));
	} else if(index == 6) {
		// X^vIĂꍇ
		color -> hide();
		bgcolor -> hide();
		bar_type -> hide();
		
	} else if(index == 7) {
		// ͈͂IĂꍇ
		color -> hide();
		bgcolor -> hide();
		bar_type -> show();
		
		bar_type -> clear();
		bar_type -> insertItem(codec->toUnicode("폜"));
		bar_type -> insertItem(codec->toUnicode("Jbg"));
		bar_type -> insertItem(codec->toUnicode("Rs["));
		bar_type -> insertItem(codec->toUnicode("y[Xg"));
		bar_type -> insertItem(codec->toUnicode("]"));
		bar_type -> insertItem(codec->toUnicode("E]"));
		bar_type -> insertItem(codec->toUnicode("㉺]"));
		bar_type -> insertItem(codec->toUnicode("E]"));
		bar_type -> insertItem(codec->toUnicode(""));
	}
}



// }EXꂽƂ̃Cxg
void Mainwindow::mousePressEvent( QMouseEvent *e )
{
	mx = e -> QMouseEvent::x();  // }EX̂wW
	my = e -> QMouseEvent::y();  // }EX̂xW
	
	QPainter qp;
	qp.begin(&buffer);
	qp.setPen(QColor::QColor(0, 0, 0));
	qp.setBrush(QColor::QColor(0, 0, 0));
	qp.drawEllipse( mx, my, 1+pen_size*3, 1+pen_size*3);
	qp.end();
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	
	mx_pre = mx;
	my_pre = my;
}



// }EXꂽƂ̃Cxg
void Mainwindow::mouseMoveEvent( QMouseEvent *e )
{
	mx = e -> QMouseEvent::x();  // }EX̂wW
	my = e -> QMouseEvent::y();  // }EX̂xW
	
	pen.setWidth(1+pen_size*3);
	pen.setColor(QColor::QColor(0, 0, 0));
	
	QPainter qp;
	qp.begin(&buffer);
	qp.setPen(pen);
	qp.drawLine(mx_pre, my_pre, mx, my);
	qp.end();
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	
	mx_pre = mx;
	my_pre = my;
}



// }EX͂ȂꂽƂ̃Cxg
void Mainwindow::mouseReleaseEvent( QMouseEvent *e )
{
	mx = e -> QMouseEvent::x();  // }EX̂wW
	my = e -> QMouseEvent::y();  // }EX̂xW
}



// `悷Ƃ̃Cxg
void Mainwindow::paintEvent( QPaintEvent * )
{
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
}