#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qmainwindow.h>   // gpNXw肷
#include <qapplication.h>
#include <qtextcodec.h>
#include <qfont.h>
#include <qmenubar.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qpicture.h>
#include <qpen.h>

class Mainwindow : public QWidget{
	Q_OBJECT

public:
	Mainwindow(QWidget *parent = 0, const char *name = 0);

protected:
	void paintEvent( QPaintEvent * );  // `掞ɗp
    void mousePressEvent( QMouseEvent *e );  // }EXꂽ̃Cxg
    void mouseMoveEvent( QMouseEvent *e );  // }EXꂽ̃Cxg
    void mouseReleaseEvent( QMouseEvent *e );  // }EX͂Ȃꂽ̃Cxg

private:
	
	int mx, my; // }EX|C^̍W
	int mx_pre, my_pre; // Õ}EX|C^̍W
	int index;  // IĂỹ^Cv
	int pen_size;  // ỹTCY
	
	QTextCodec *codec; // eLXgR[fbN
	QMenuBar *menubar; // j[o[
	QComboBox *pen_type, *bar_type, *c_type, *bg_type; // R{{bNX
	QPushButton *erase, *color, *bgcolor;
	QPixmap fm_pen, fm_line, fm_rightangle, fm_rectangle, fm_paintrectangle, fm_eraser, fm_stamp, fm_range, fm_thickline, fm_normalline, fm_thinline, fm_paint, fm_minieraser;
	QPixmap buffer;
	QPen pen;

private slots :
	void slot_setPen();
	void slot_change_PenSize();
};

#endif //MAINWINDOW_H